//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%44CE45DC00FE.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%44CE45DC00FE.cm

//## begin module%44CE45DC00FE.cp preserve=no
//## end module%44CE45DC00FE.cp

//## Module: PsfTraits%44CE45DC00FE; Package specification
//## Subsystem: XSModel::Model::MixFunction%3F74624902C0
//## Source file: /data/gordon/headas/Xspec/src/XSModel/Model/MixFunction/PsfTraits.h

#ifndef PSFTRAITS_H
#define PSFTRAITS_H 1

//## begin module%44CE45DC00FE.additionalIncludes preserve=no
//## end module%44CE45DC00FE.additionalIncludes

//## begin module%44CE45DC00FE.includes preserve=yes
#include <xsTypes.h>
#include <string>
//## end module%44CE45DC00FE.includes


template <typename T> class Psf;
template <typename T> class PsfRegion;

//## begin module%44CE45DC00FE.declarations preserve=no
//## end module%44CE45DC00FE.declarations

//## begin module%44CE45DC00FE.additionalDeclarations preserve=yes
//## end module%44CE45DC00FE.additionalDeclarations


//## begin XMM%44CE46BD02F0.preface preserve=yes
//## end XMM%44CE46BD02F0.preface

//## Class: XMM%44CE46BD02F0
//	These are essentially combined traits and policy
//	classes, since it's difficult to imagine a future case
//	where one would want these uncoupled (ie. XMM string
//	labels with Suzaku psf calculation method).
//## Category: XSModel::Model::MixFunction%3F7461FF026E
//## Subsystem: XSModel::Model::MixFunction%3F74624902C0
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%44CE47E303B5;Psf { -> F}
//## Uses: <unnamed>%44CE68BE0204;PsfRegion { -> F}

class XMM 
{
  //## begin XMM%44CE46BD02F0.initialDeclarations preserve=yes
  //## end XMM%44CE46BD02F0.initialDeclarations

  public:

    //## Other Operations (specified)
      //## Operation: pointSpreadFunction%44CE59660088
      static void pointSpreadFunction (Psf<XMM>& psf, size_t iObs, size_t iReg, int ixb, int iyb, size_t iEng);

      //## Operation: readSpecificMapKeys%44CE5FB403A8
      static void readSpecificMapKeys (PsfRegion<XMM>& region);

    // Data Members for Class Attributes

      //## Attribute: keywordRoot%44CE48E7030F
      //## begin XMM::keywordRoot%44CE48E7030F.attr preserve=no  public: static const string {U} string("XMMPSF")
      static const string keywordRoot;
      //## end XMM::keywordRoot%44CE48E7030F.attr

    // Additional Public Declarations
      //## begin XMM%44CE46BD02F0.public preserve=yes
      static const size_t NE;
      static const Real psfEnergy[];
      //## end XMM%44CE46BD02F0.public
  protected:
    // Additional Protected Declarations
      //## begin XMM%44CE46BD02F0.protected preserve=yes
      //## end XMM%44CE46BD02F0.protected

  private:
    // Additional Private Declarations
      //## begin XMM%44CE46BD02F0.private preserve=yes
      //## end XMM%44CE46BD02F0.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin XMM%44CE46BD02F0.implementation preserve=yes
      //## end XMM%44CE46BD02F0.implementation

};

//## begin XMM%44CE46BD02F0.postscript preserve=yes
//## end XMM%44CE46BD02F0.postscript

//## begin Suzaku%44CE474E03A2.preface preserve=yes
//## end Suzaku%44CE474E03A2.preface

//## Class: Suzaku%44CE474E03A2
//## Category: XSModel::Model::MixFunction%3F7461FF026E
//## Subsystem: XSModel::Model::MixFunction%3F74624902C0
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class Suzaku 
{
  //## begin Suzaku%44CE474E03A2.initialDeclarations preserve=yes
  //## end Suzaku%44CE474E03A2.initialDeclarations

  public:

    //## Other Operations (specified)
      //## Operation: pointSpreadFunction%44CE5A810189
      static void pointSpreadFunction (Psf<Suzaku>& psf, size_t iObs, size_t iReg, int ixb, int iyb, size_t iEng);

      //## Operation: readSpecificMapKeys%44CE6069022F
      static void readSpecificMapKeys (PsfRegion<Suzaku>& region);

    // Data Members for Class Attributes

      //## Attribute: keywordRoot%44CE5A8C038C
      //## begin Suzaku::keywordRoot%44CE5A8C038C.attr preserve=no  public: static const string {U} string("SUZPSF")
      static const string keywordRoot;
      //## end Suzaku::keywordRoot%44CE5A8C038C.attr

    // Additional Public Declarations
      //## begin Suzaku%44CE474E03A2.public preserve=yes
      static const size_t NE;
      static const Real psfEnergy[];
      //## end Suzaku%44CE474E03A2.public
  protected:
    // Additional Protected Declarations
      //## begin Suzaku%44CE474E03A2.protected preserve=yes
      //## end Suzaku%44CE474E03A2.protected

  private:
    // Additional Private Declarations
      //## begin Suzaku%44CE474E03A2.private preserve=yes
      //## end Suzaku%44CE474E03A2.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin Suzaku%44CE474E03A2.implementation preserve=yes
      //## end Suzaku%44CE474E03A2.implementation

};

//## begin Suzaku%44CE474E03A2.postscript preserve=yes
//## end Suzaku%44CE474E03A2.postscript

// Class XMM 

// Class Suzaku 

//## begin module%44CE45DC00FE.epilog preserve=yes
//## end module%44CE45DC00FE.epilog


#endif
